Subject: Re: Probing for native availability of isel from userspace

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sun, 23 Sep 2012 05:55:37 +1000

On Sat, 2012-09-22 at 21:08 +0200, Segher Boessenkool wrote:
> > Thanks for suggestion, but i'd rather not play with heuristics.
> 
> Have a look at /sys/kernel/debug/powerpc/emulated_instructions/ then?

Userspace should *NEVER* rely on the content of debugfs, it will change
with time, it is not a guaranteed ABI, it's purely for people to look
at... for debugging.

Unfortunately we don't expose ISEL support via features (maybe we
should, this is reasonably easy to fix, except that we are running short
on feature bits and adding a new set of bits isn't totally trivial).

At this stage I would recommend using arch 2.06 as your key/trigger and
either add a handful of known PVR values (mfpvr is emulated) for other
CPUs you know support it (there shouldn't be that many), or just do the
heuristic :-(

Cheers,
Ben.